// Code generated by SQLBoiler (https://github.com/volatiletech/sqlboiler). DO NOT EDIT.
// This file is meant to be re-generated in place and/or deleted at any time.

package postgres

import (
	"bytes"
	"context"
	"reflect"
	"testing"

	"github.com/volatiletech/sqlboiler/boil"
	"github.com/volatiletech/sqlboiler/queries"
	"github.com/volatiletech/sqlboiler/randomize"
	"github.com/volatiletech/sqlboiler/strmangle"
)

var (
	// Relationships sometimes use the reflection helper queries.Equal/queries.Assign
	// so force a package dependency in case they don't.
	_ = queries.Equal
)

func testTransports(t *testing.T) {
	t.Parallel()

	query := Transports()

	if query.Query == nil {
		t.Error("expected a query, got nothing")
	}
}

func testTransportsDelete(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := o.Delete(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Transports().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testTransportsQueryDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if rowsAff, err := Transports().DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Transports().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testTransportsSliceDeleteAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := TransportSlice{o}

	if rowsAff, err := slice.DeleteAll(ctx, tx); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only have deleted one row, but affected:", rowsAff)
	}

	count, err := Transports().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 0 {
		t.Error("want zero records, got:", count)
	}
}

func testTransportsExists(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	e, err := TransportExists(ctx, tx, o.ID)
	if err != nil {
		t.Errorf("Unable to check if Transport exists: %s", err)
	}
	if !e {
		t.Errorf("Expected TransportExists to return true, but got false.")
	}
}

func testTransportsFind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	transportFound, err := FindTransport(ctx, tx, o.ID)
	if err != nil {
		t.Error(err)
	}

	if transportFound == nil {
		t.Error("want a record, got nil")
	}
}

func testTransportsBind(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = Transports().Bind(ctx, tx, o); err != nil {
		t.Error(err)
	}
}

func testTransportsOne(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if x, err := Transports().One(ctx, tx); err != nil {
		t.Error(err)
	} else if x == nil {
		t.Error("expected to get a non nil record")
	}
}

func testTransportsAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	transportOne := &Transport{}
	transportTwo := &Transport{}
	if err = randomize.Struct(seed, transportOne, transportDBTypes, false, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}
	if err = randomize.Struct(seed, transportTwo, transportDBTypes, false, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = transportOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = transportTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := Transports().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 2 {
		t.Error("want 2 records, got:", len(slice))
	}
}

func testTransportsCount(t *testing.T) {
	t.Parallel()

	var err error
	seed := randomize.NewSeed()
	transportOne := &Transport{}
	transportTwo := &Transport{}
	if err = randomize.Struct(seed, transportOne, transportDBTypes, false, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}
	if err = randomize.Struct(seed, transportTwo, transportDBTypes, false, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = transportOne.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}
	if err = transportTwo.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Transports().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 2 {
		t.Error("want 2 records, got:", count)
	}
}

func transportBeforeInsertHook(ctx context.Context, e boil.ContextExecutor, o *Transport) error {
	*o = Transport{}
	return nil
}

func transportAfterInsertHook(ctx context.Context, e boil.ContextExecutor, o *Transport) error {
	*o = Transport{}
	return nil
}

func transportAfterSelectHook(ctx context.Context, e boil.ContextExecutor, o *Transport) error {
	*o = Transport{}
	return nil
}

func transportBeforeUpdateHook(ctx context.Context, e boil.ContextExecutor, o *Transport) error {
	*o = Transport{}
	return nil
}

func transportAfterUpdateHook(ctx context.Context, e boil.ContextExecutor, o *Transport) error {
	*o = Transport{}
	return nil
}

func transportBeforeDeleteHook(ctx context.Context, e boil.ContextExecutor, o *Transport) error {
	*o = Transport{}
	return nil
}

func transportAfterDeleteHook(ctx context.Context, e boil.ContextExecutor, o *Transport) error {
	*o = Transport{}
	return nil
}

func transportBeforeUpsertHook(ctx context.Context, e boil.ContextExecutor, o *Transport) error {
	*o = Transport{}
	return nil
}

func transportAfterUpsertHook(ctx context.Context, e boil.ContextExecutor, o *Transport) error {
	*o = Transport{}
	return nil
}

func testTransportsHooks(t *testing.T) {
	t.Parallel()

	var err error

	ctx := context.Background()
	empty := &Transport{}
	o := &Transport{}

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, o, transportDBTypes, false); err != nil {
		t.Errorf("Unable to randomize Transport object: %s", err)
	}

	AddTransportHook(boil.BeforeInsertHook, transportBeforeInsertHook)
	if err = o.doBeforeInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeInsertHook function to empty object, but got: %#v", o)
	}
	transportBeforeInsertHooks = []TransportHook{}

	AddTransportHook(boil.AfterInsertHook, transportAfterInsertHook)
	if err = o.doAfterInsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterInsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterInsertHook function to empty object, but got: %#v", o)
	}
	transportAfterInsertHooks = []TransportHook{}

	AddTransportHook(boil.AfterSelectHook, transportAfterSelectHook)
	if err = o.doAfterSelectHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterSelectHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterSelectHook function to empty object, but got: %#v", o)
	}
	transportAfterSelectHooks = []TransportHook{}

	AddTransportHook(boil.BeforeUpdateHook, transportBeforeUpdateHook)
	if err = o.doBeforeUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpdateHook function to empty object, but got: %#v", o)
	}
	transportBeforeUpdateHooks = []TransportHook{}

	AddTransportHook(boil.AfterUpdateHook, transportAfterUpdateHook)
	if err = o.doAfterUpdateHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpdateHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpdateHook function to empty object, but got: %#v", o)
	}
	transportAfterUpdateHooks = []TransportHook{}

	AddTransportHook(boil.BeforeDeleteHook, transportBeforeDeleteHook)
	if err = o.doBeforeDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeDeleteHook function to empty object, but got: %#v", o)
	}
	transportBeforeDeleteHooks = []TransportHook{}

	AddTransportHook(boil.AfterDeleteHook, transportAfterDeleteHook)
	if err = o.doAfterDeleteHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterDeleteHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterDeleteHook function to empty object, but got: %#v", o)
	}
	transportAfterDeleteHooks = []TransportHook{}

	AddTransportHook(boil.BeforeUpsertHook, transportBeforeUpsertHook)
	if err = o.doBeforeUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doBeforeUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected BeforeUpsertHook function to empty object, but got: %#v", o)
	}
	transportBeforeUpsertHooks = []TransportHook{}

	AddTransportHook(boil.AfterUpsertHook, transportAfterUpsertHook)
	if err = o.doAfterUpsertHooks(ctx, nil); err != nil {
		t.Errorf("Unable to execute doAfterUpsertHooks: %s", err)
	}
	if !reflect.DeepEqual(o, empty) {
		t.Errorf("Expected AfterUpsertHook function to empty object, but got: %#v", o)
	}
	transportAfterUpsertHooks = []TransportHook{}
}

func testTransportsInsert(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Transports().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testTransportsInsertWhitelist(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Whitelist(transportColumnsWithoutDefault...)); err != nil {
		t.Error(err)
	}

	count, err := Transports().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}
}

func testTransportToOneDriverUsingDriver(t *testing.T) {
	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var local Transport
	var foreign Driver

	seed := randomize.NewSeed()
	if err := randomize.Struct(seed, &local, transportDBTypes, false, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}
	if err := randomize.Struct(seed, &foreign, driverDBTypes, false, driverColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Driver struct: %s", err)
	}

	if err := foreign.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	local.DriverID = foreign.ID
	if err := local.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	check, err := local.Driver().One(ctx, tx)
	if err != nil {
		t.Fatal(err)
	}

	if check.ID != foreign.ID {
		t.Errorf("want: %v, got %v", foreign.ID, check.ID)
	}

	slice := TransportSlice{&local}
	if err = local.L.LoadDriver(ctx, tx, false, (*[]*Transport)(&slice), nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Driver == nil {
		t.Error("struct should have been eager loaded")
	}

	local.R.Driver = nil
	if err = local.L.LoadDriver(ctx, tx, true, &local, nil); err != nil {
		t.Fatal(err)
	}
	if local.R.Driver == nil {
		t.Error("struct should have been eager loaded")
	}
}

func testTransportToOneSetOpDriverUsingDriver(t *testing.T) {
	var err error

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()

	var a Transport
	var b, c Driver

	seed := randomize.NewSeed()
	if err = randomize.Struct(seed, &a, transportDBTypes, false, strmangle.SetComplement(transportPrimaryKeyColumns, transportColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &b, driverDBTypes, false, strmangle.SetComplement(driverPrimaryKeyColumns, driverColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}
	if err = randomize.Struct(seed, &c, driverDBTypes, false, strmangle.SetComplement(driverPrimaryKeyColumns, driverColumnsWithoutDefault)...); err != nil {
		t.Fatal(err)
	}

	if err := a.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}
	if err = b.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Fatal(err)
	}

	for i, x := range []*Driver{&b, &c} {
		err = a.SetDriver(ctx, tx, i != 0, x)
		if err != nil {
			t.Fatal(err)
		}

		if a.R.Driver != x {
			t.Error("relationship struct not set to correct value")
		}

		if x.R.Transports[0] != &a {
			t.Error("failed to append to foreign relationship struct")
		}
		if a.DriverID != x.ID {
			t.Error("foreign key was wrong value", a.DriverID)
		}

		zero := reflect.Zero(reflect.TypeOf(a.DriverID))
		reflect.Indirect(reflect.ValueOf(&a.DriverID)).Set(zero)

		if err = a.Reload(ctx, tx); err != nil {
			t.Fatal("failed to reload", err)
		}

		if a.DriverID != x.ID {
			t.Error("foreign key was wrong value", a.DriverID, x.ID)
		}
	}
}

func testTransportsReload(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	if err = o.Reload(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testTransportsReloadAll(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice := TransportSlice{o}

	if err = slice.ReloadAll(ctx, tx); err != nil {
		t.Error(err)
	}
}

func testTransportsSelect(t *testing.T) {
	t.Parallel()

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	slice, err := Transports().All(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if len(slice) != 1 {
		t.Error("want one record, got:", len(slice))
	}
}

var (
	transportDBTypes = map[string]string{`ID`: `bigint`, `DriverID`: `bigint`, `Name`: `character varying`, `Tariff`: `bigint`, `Cost`: `bigint`, `Carryng`: `numeric`}
	_                = bytes.MinRead
)

func testTransportsUpdate(t *testing.T) {
	t.Parallel()

	if 0 == len(transportPrimaryKeyColumns) {
		t.Skip("Skipping table with no primary key columns")
	}
	if len(transportColumns) == len(transportPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Transports().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, transportDBTypes, true, transportPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	if rowsAff, err := o.Update(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("should only affect one row but affected", rowsAff)
	}
}

func testTransportsSliceUpdateAll(t *testing.T) {
	t.Parallel()

	if len(transportColumns) == len(transportPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	o := &Transport{}
	if err = randomize.Struct(seed, o, transportDBTypes, true, transportColumnsWithDefault...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Insert(ctx, tx, boil.Infer()); err != nil {
		t.Error(err)
	}

	count, err := Transports().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}

	if count != 1 {
		t.Error("want one record, got:", count)
	}

	if err = randomize.Struct(seed, o, transportDBTypes, true, transportPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	// Remove Primary keys and unique columns from what we plan to update
	var fields []string
	if strmangle.StringSliceMatch(transportColumns, transportPrimaryKeyColumns) {
		fields = transportColumns
	} else {
		fields = strmangle.SetComplement(
			transportColumns,
			transportPrimaryKeyColumns,
		)
	}

	value := reflect.Indirect(reflect.ValueOf(o))
	typ := reflect.TypeOf(o).Elem()
	n := typ.NumField()

	updateMap := M{}
	for _, col := range fields {
		for i := 0; i < n; i++ {
			f := typ.Field(i)
			if f.Tag.Get("boil") == col {
				updateMap[col] = value.Field(i).Interface()
			}
		}
	}

	slice := TransportSlice{o}
	if rowsAff, err := slice.UpdateAll(ctx, tx, updateMap); err != nil {
		t.Error(err)
	} else if rowsAff != 1 {
		t.Error("wanted one record updated but got", rowsAff)
	}
}

func testTransportsUpsert(t *testing.T) {
	t.Parallel()

	if len(transportColumns) == len(transportPrimaryKeyColumns) {
		t.Skip("Skipping table with only primary key columns")
	}

	seed := randomize.NewSeed()
	var err error
	// Attempt the INSERT side of an UPSERT
	o := Transport{}
	if err = randomize.Struct(seed, &o, transportDBTypes, true); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	ctx := context.Background()
	tx := MustTx(boil.BeginTx(ctx, nil))
	defer func() { _ = tx.Rollback() }()
	if err = o.Upsert(ctx, tx, false, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert Transport: %s", err)
	}

	count, err := Transports().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}

	// Attempt the UPDATE side of an UPSERT
	if err = randomize.Struct(seed, &o, transportDBTypes, false, transportPrimaryKeyColumns...); err != nil {
		t.Errorf("Unable to randomize Transport struct: %s", err)
	}

	if err = o.Upsert(ctx, tx, true, nil, boil.Infer(), boil.Infer()); err != nil {
		t.Errorf("Unable to upsert Transport: %s", err)
	}

	count, err = Transports().Count(ctx, tx)
	if err != nil {
		t.Error(err)
	}
	if count != 1 {
		t.Error("want one record, got:", count)
	}
}
